import java.util.Iterator;

public class Monster {
    private final int number;
    private final String name;
    private final String locations;
    private final String drop1;
    private final float chance1;
    private final String drop2;
    private final float chance2;

    public Monster(Iterator<String> iter) {
        this.number = Integer.parseInt(iter.next());
        this.name = iter.next();
        this.locations = iter.next();
        this.drop1 = iter.next();
        this.chance1 = Float.parseFloat(iter.next());
        this.drop2 = iter.next();
        this.chance2 = Float.parseFloat(iter.next());
    }

    public int getNumber() {
        return number;
    }

    public String getName() {
        return name;
    }

    public String getLocations() {
        return locations;
    }

    public float getFirstChance() {
        return chance1;
    }

    public float getSecondChance() {
        return chance2;
    }

    public String getFirstDrop() {
        return drop1;
    }

    public String getSecondDrop() {
        return drop2;
    }

    @Override
    public String toString() {
        return String.format("%3d | %21s | %22s %6.2f %% | %22s %6.2f %%", number, name, drop1,
                chance1, drop2, chance2);
    }
}
