import java.util.List;
import java.util.function.Predicate;

public class NumberFilter {
    private Predicate<Integer> pred = (i) -> false;

    public NumberFilter(List<String> parts) {
        for(String s : parts) {
            try {
                try {
                    int n = Integer.parseInt(s);
                    pred = pred.or((i) -> i == n);
                } catch(NumberFormatException ex) {
                    int index = s.indexOf("-");
                    int a = Integer.parseInt(s.substring(0, index));
                    int b = Integer.parseInt(s.substring(index + 1));
                    pred = pred.or((i) -> i >= a && i <= b);
                }
            } catch(Exception ex) {
                System.out.println(String.format("Ungültiges Filter-Argument: %s", s));
            }
        }
    }

    public boolean check(int i) {
        return pred.test(i);
    }
}
