import java.util.HashSet;

public class Recipe implements Comparable<Recipe> {
    private static int idCounter = 0;
    private int id = idCounter++;

    private String category;
    private String result;
    private final int[] amount = new int[] {0, 0, 0};
    private final String[] item = new String[] {null, null, null};

    public void setCategory(String category) {
        this.category = category;
    }

    public String getCategory() {
        return category;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getResult() {
        return result;
    }

    public void setItem(int index, String item, int amount) {
        this.amount[index] = amount;
        this.item[index] = item;
    }

    public boolean check(HashSet<String> items) {
        return items.contains(item[0]) && (amount[1] == 0 || items.contains(item[1]))
                && (amount[2] == 0 || items.contains(item[2]));
    }

    public boolean has(String item) {
        return item.equals(this.item[0]) || item.equals(this.item[1]) || item.equals(this.item[2]);
    }

    @Override
    public String toString() {
        String spaces = "                           ";
        if(amount[1] == 0) {
            return String.format("%15s | %23s | %23s (%d) | %s | %s", category, result, item[0],
                    amount[0], spaces, spaces);
        } else if(amount[2] == 0) {
            return String.format("%15s | %23s | %23s (%d) | %23s (%d) | %s", category, result,
                    item[0], amount[0], item[1], amount[1], spaces);
        }
        return String.format("%15s | %23s | %23s (%d) | %23s (%d) | %23s (%d)", category, result,
                item[0], amount[0], item[1], amount[1], item[2], amount[2]);
    }

    @Override
    public int compareTo(Recipe o) {
        int c = category.compareTo(o.category);
        if(c == 0) {
            return Integer.compare(id, o.id);
        }
        return c;
    }
}
