import java.util.ArrayList;
import java.util.HashSet;

public class Shop {
    public static class Item {
        private final String name;
        private final int cost;

        public Item(String name, int cost) {
            this.name = name;
            this.cost = cost;
        }

        public int getCost() {
            return cost;
        }

        public String getName() {
            return name;
        }
    }

    private final String name;
    private final ArrayList<Item> shopItems = new ArrayList<>();

    public Shop(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void addItem(String name, int cost) {
        shopItems.add(new Item(name, cost));
    }

    public void addAllTo(HashSet<String> list) {
        shopItems.forEach(item -> list.add(item.name));
    }

    public Item search(String name) {
        for(Item item : shopItems) {
            if(item.name.equals(name)) {
                return item;
            }
        }
        return null;
    }
}
